/**
 * Created by whh on 2017/12/26.
 */
import React, {Component} from 'react';
import {NavBar} from 'antd-mobile';
import YYIcon from '../../component/icon/YYIcon'
import _ from 'lodash';
import classnames from 'classnames';
import {backOrClose} from '../../utils/lfwUtil';
import './YYNavBar.css';

class YYNavBar extends Component {
    /**
     * 默认进行返回 or 关闭
     */
    onLeftClick = (e) => {
        if(this.props.RunInDesign){
            return;
        }
        if (_.isFunction(this.props.onLeftClick)) {
            this.props.onLeftClick(e);
        }else{
            backOrClose();
        }
    }
    /****右击事件*****/
    onRightClick(e){
        if(_.isFunction(this.props.onRightClick)) {
            this.props.onRightClick(e);
        }
    }
    render() {
        let {mode, leftIcon, leftContent, rightIcon, rightContent, children, className,visible, ...restProps} = this.props;
        let wrapClz = classnames('yy-navBar',(!visible&&'hidden'), className);
        //leftIcon左边按钮 字符串时认为是按钮类型
        let leftIconCom=typeof(leftIcon)==='string'?<YYIcon type={leftIcon}/>:leftIcon;
        let rightCom=rightIcon?<span className="rightContent" onClick={this.onRightClick.bind(this)}>{rightContent}<YYIcon className="rightIcon" type={rightIcon}/></span>:<span className="rightContent" onClick={this.onRightClick.bind(this)}>{rightContent}</span>;
        return (
            <NavBar {...restProps}
                    className={wrapClz}
                    mode={mode}
                    icon={leftIconCom}
                    leftContent={leftContent}
                    onLeftClick={this.onLeftClick}
                    rightContent={rightCom}>
                {children}
            </NavBar>
        );
    }
}
YYNavBar.defaultProps = {
    mode:'light',
    leftIcon:null,
    leftContent: null,
    rightIcon: null,
    rightContent: null,
    onLeftClick:null,
    visible:true,

};
export default YYNavBar;