import React from 'react';
import { Radio, Checkbox, Modal, List, WhiteSpace, WingBlank,  Toast, ActivityIndicator, NavBar, SearchBar, Icon, Accordion,Tabs,SwipeAction,Badge} from 'antd-mobile';
import './refer.less'
import DeleteTap from '../delete-tap/deleteTap'
import ajax from '../../utils/ajax';
import RestUrl from "../../common/RestUrl";
import _ from 'lodash';

// import closest from '../../_util/closest';
let ListItem = List.Item;
let CheckboxItem = Checkbox.CheckboxItem;
let RadioItem = Radio.RadioItem;
let page;
let referUrl=[];
let treereferUrl=[];
let relyfield=[];
let referParams;
let data=[];

export default class YYReferTree extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data:[],        //分页初始数据
            value:'',       //选择的值
            selectedId: null,
            selectedNode: {},
            selectedNodes: [],
            animating: false,
            pageCount:'',
            searchText:'',
            showList:false, //tree-list的modal
            row:[],     //选中的数组
        };
    }

    componentDidMount() {

    }
    componentWillReceiveProps(nextprops){
        if(nextprops.open!==this.props.open){
            if(nextprops.open){
                page = this;
                let name = this.props.referName;
                let open = this.props.open;
                page.setState({
                    [name]:open,
                    row:[]
                })
                let referCode = page.props.referCode;
                let referStyle = page.props.referStyle;
                //根据参照编码获取参照信息
                ajax.getJSON(RestUrl.REF_SERVER_URL + RestUrl.GET_REFINFO_BYCODE, {refCode: referCode}, function (result) {
                    if (result.success) {
                        // console.log(result.data);
                        if(result.data !== null){
                            referUrl[name] = result.data.dataurl;
                            treereferUrl[name] = result.data.treerelyurl;
                            relyfield[name] = result.data.relyfield;
                            referParams = {};
                            // console.log(page.state.row);
                            page.setState({
                                referName: result.data.refName,
                                referUrl: referUrl,
                                selectedNodes:[],       //清空上次已选择
                            })
                            referParams.condition = page.props.condition;


                            page.getTreeData(referUrl[name], referParams,name);

                        } else {
                            Toast.fail(result.msg,2)
                        }


                    } else {
                        Toast.fail("请检查参照编码!", 3);
                    }

                }, function (err) {
                    Toast.fail("服务器通讯异常!", 3);
                })

            }
        }

    }
    getTreeData (referUrl, referParams, contentname){
        let _self = this;
        _self.setState({
            animating: true
        })
        ajax.getText(referUrl, referParams, function (result) {
            result = JSON.parse(result);

            if(result.length!==0){
                let hasSuccess = Object.getOwnPropertyNames(result);
                for(var i = 0 ; i < hasSuccess.length ; i++){
                    if(hasSuccess[i]=='success'){
                        if(!result.success){
                            _self.setState({
                                // data: result,
                                animating: false
                            })
                            Toast.info(result.backMsg,2);
                            return false;
                        }
                    }
                }
                data[contentname]=result;
                data[contentname+'tree']=result;
                //增加常用列表
                if (localStorage.getItem(_self.props.referCode+_self.props.orgcode+'used') === null) {
                    data[contentname + 'used'] = [];
                } else {
                    data[contentname + 'used'] = JSON.parse(localStorage.getItem(_self.props.referCode+_self.props.orgcode+'used'))
                }
                _self.setState({
                    // data: result,
                    animating: false
                })
            } else {
                _self.setState({
                    // data: result,
                    animating: false
                })
                Toast.info('参照信息为空',2);
            }


        }, function (err) {
            _self.setState({
                animating: false
            })
            Toast.fail("服务器通讯异常!", 1);
        })
    }

    onMultiChange = (e,selectedNode) => {
        //多选模式
        if(selectedNode.selectable!==false){
            let selectedNodes = this.state.selectedNodes;
            if (!selectedNodes.some((item) => {
                    return item.id === selectedNode.id
                })) {
                // console.log('1')
                selectedNodes.push(selectedNode);
                selectedNode.checked=true;
                this.setState({
                    selectedNodes: selectedNodes,
                    row:selectedNodes
                });
            } else {
                // console.log('2')
                let newNodes = [];
                // eslint-disable-next-line
                selectedNodes.map((item) => {
                    if (item.id !== selectedNode.id) {
                        newNodes.push(item);
                    }
                })
                selectedNode.checked=false;
                this.setState({
                    selectedNodes: newNodes,
                    row:newNodes
                });
            }
        } else {
            Toast.info('该项目不可选',1);
        }

    }

    onSingleChange = (e,selectedNode) => {
        console.log('单选');
        if(selectedNode.selectable!==false){
            //单选模式
            if (selectedNode[this.props.id] === this.state.selectedId) {
                this.setState({
                    selectedId: null,
                    selectedNode: {}
                });
            } else {
                this.setState({
                    selectedId: selectedNode[this.props.id],
                    selectedNode: selectedNode
                });
            };
            if(!this.props.custom){
                //选中后直接onOK
                setTimeout(()=>{
                    this.setState({
                        pageNumber:1,
                        searchText:'',
                        showList:false,
                    })
                    let referParams = {};
                    referParams.condition = this.props.condition;

                    // this.getListData(referUrl[this.props.referName], referParams, 1,this.props.referName);

                    if (this.props.onOk && _.isFunction(this.props.onOk)) {
                        if (!this.props.multiMode) {
                            this.props.onOk(this.state.selectedNode,this.props.referName);
                            this.setState({
                                selectedId:null
                            })
                        } else {
                            this.props.onOk(this.state.selectedNodes,this.props.referName);
                            //清空上次选择
                            this.setState({
                                selectedNodes:[],
                            })

                        }
                    }
                },0)
            }

        } else {
            Toast.info('该项目不可选',1);
        }


    }

    showModal = key => (e) => {
        e.preventDefault(); // 修复 Android 上点击穿透
        this.setState({
            [key]: true,
        });
    }
    onClose = key => (e) => {
        //初始化列表数据后再关闭
        // let referUrl = this.state.referUrl;
        let referParams = {};
        referParams.condition = this.props.condition;
        this.setState({
            showList:false,
            searchText:'',
        })
        this.props.onClose(key);
    }
    onOk = key =>(e)=> {
        let _self = this;
        this.setState({
            pageNumber:1,
            searchText:'',
            showList:false,
        })
        let referParams = {};
        referParams.condition = this.props.condition;

        // this.getListData(referUrl[this.props.referName], referParams, 1,this.props.referName);

        if (this.props.onOk && _.isFunction(this.props.onOk)) {
            if (!this.props.multiMode) {
                this.props.onOk(this.state.selectedNode,key);
                this.setState({
                    selectedId:null
                })
            } else {
                this.props.onOk(this.state.selectedNodes,key);
                //清空上次选择
                this.setState({
                    selectedNodes:[],
                })

            }
        }
    }
    onSearchSubmit = (value) => {
        let totalData = data[this.props.referName];
        let searchData = [];            //储存搜索出来的结果
        let searchKey = this.props.displayField;   //需要搜索的key
        if(value == ''){
            data[this.props.referName+'tree'] = data[this.props.referName];
            this.setState({
                animating:false,
            })
        } else {
            let search = (searchText,data)=>{
                for(let i = 0 ; i < data.length; i++){
                    if(data[i][searchKey].includes(searchText)){
                        searchData.push(data[i])
                    }
                    if(data[i].children !== null){
                        search(searchText,data[i].children)
                    }
                }
            }

            search(value,totalData);
            data[this.props.referName+'tree']=searchData;
            this.setState({
                animating:false,
            })
        }

        /* this.setState({
             searchText:value,
         })
         let referParams = {};
         referParams.searchText = value;
         referParams.pageSize = 10;
         referParams.condition = this.props.condition;
         this.getListData(referUrl[this.props.referName], referParams, 1,this.props.referName);*/


    }
    //切换到常用标签时渲染
    TabChange = (tab, index) => {
        if (index === 0) {
            data[this.props.referName + 'used'] = JSON.parse(localStorage.getItem(this.props.referCode+this.props.orgcode+'used'));
            this.setState({test: ''});
            console.log(data[this.props.referName + 'used'])
        } else {
            console.log('onTabClick', index, tab);
        }
    }
    //加入常用列表
    addUsed = (value) => {
        let addList = JSON.parse(localStorage.getItem(this.props.referCode+this.props.orgcode+'used'));
        if (addList === null) {
            addList = [];
        } else {
            //遍历是否有重复项
            for(let i = 0; i < addList.length; i++){
                if(addList[i].id === value.id){
                    console.log('有重复项');
                    Toast.info('已在常用列表中，请勿重复添加', 1.5);
                    return false;

                }
            }
        }
        value.checked = false;
        addList.push(value);
        Toast.info('添加常用列表成功', 1);
        data[this.props.referName + 'used'] = addList;
        console.log(data[this.props.referName+'used']);
        addList = JSON.stringify(addList)
        localStorage.setItem(this.props.referCode+this.props.orgcode+'used', addList);
    }
    //删除常用列表项
    deleteUsed = (value, index) => {
        console.log(value);
        console.log(index);
        let usedData = JSON.parse(localStorage.getItem(this.props.referCode+this.props.orgcode+'used'));
        usedData.splice(index, 1);
        data[this.props.referName + 'used'] = usedData;
        localStorage.setItem(this.props.referCode+this.props.orgcode+'used', JSON.stringify(usedData));
        this.setState({
            test: ''
        })
    }
    //常用列表渲染
    usedTreeContent = (treeData,selectedId,show) => {
        if(!this.props.multiMode){
            if(treeData){
                return treeData.map((item,index) => {
                    let arrow = '';
                    if(!item.isLeaf&&!item.open&&item.children!==null){
                        arrow="right";
                    }
                    else if(!item.isLeaf&&item.open){
                        arrow="down";
                    }
                    if(show){
                        return <div style={{position:'relative',paddingLeft:'15px'}}>
                            {/*<ListItem key={index} className="refer-check-box">
                                </ListItem>*/}
                            <div className='refer-content' style={{borderBottom:'1px solid #CCCCCC'}}>
                                <SwipeAction style={{backgroundColor: 'gray'}}
                                             autoClose
                                             right={[
                                                 {
                                                     text: '取消',
                                                     onPress: () => console.log('cancel'),
                                                     style: {backgroundColor: '#ddd', color: 'white'},
                                                 },
                                                 {
                                                     text: '删除',
                                                     onPress: () => this.deleteUsed(item),
                                                     style: {backgroundColor: '#F4333C', color: 'white'},
                                                 },
                                             ]}
                                             onOpen={() => console.log('open')}
                                             onClose={() => console.log('close')}>
                                    <RadioItem  checked={false}  onChange={(e) => this.onSingleChange(e,item)} key={index}>{item[this.props.displayField]}</RadioItem>
                                    {/*{arrow!==''&&<div className='yyrefer-tree-icon-openclose' onClick={()=>{this._clickItem(item)}}>
                                    <Icon size="md"    type={arrow} color="#C7C7CC" />
                                </div>}*/}</SwipeAction>
                            </div>

                        </div>
                    }
                });
            }
        }else{
            if(treeData){
                return treeData.map((item,index) => {
                    let arrow = '';
                    if(!item.isLeaf&&!item.open&&item.children!==null){
                        arrow="right";
                    }
                    else if(!item.isLeaf&&item.open){
                        arrow="down";
                    }
                    if(show){
                        return <div style={{position:'relative',paddingLeft:'15px'}}>
                            <div className='refer-content' style={{borderBottom:'1px solid #CCCCCC'}}>
                                <SwipeAction style={{backgroundColor: 'gray'}}
                                             autoClose
                                             right={[
                                                 {
                                                     text: '取消',
                                                     onPress: () => console.log('cancel'),
                                                     style: {backgroundColor: '#ddd', color: 'white'},
                                                 },
                                                 {
                                                     text: '删除',
                                                     onPress: () => this.deleteUsed(item),
                                                     style: {backgroundColor: '#F4333C', color: 'white'},
                                                 },
                                             ]}
                                             onOpen={() => console.log('open')}
                                             onClose={() => console.log('close')}>
                                    <CheckboxItem  checked={item.checked}  onChange={(e) => this.onMultiChange(e,item)} key={item.id}>{item[this.props.displayField]}</CheckboxItem>
                                    {/*{arrow!==''&&<div className='yyrefer-tree-icon-openclose'>
                                    <Icon size="md"    type={arrow} color="#C7C7CC" onClick={()=>{this._clickItem(item)}}/>
                                </div>}*/}
                                </SwipeAction>
                            </div>
                        </div>
                    }
                });
            }
        }
    }

    //点击右边进入下一级箭头
    _clickItem = (item) => {
        // console.log(item);
        // event.stopPropagation();
        if(item.open == null){
            item.open=true;
        } else {
            item.open =!item.open;
        }
        this.setState({animating:false})
    }

    treeContent = (treeData, selectedId,show) => {
        if(!this.props.multiMode){
            if(treeData){
                return treeData.map((item,index) => {
                    let arrow = '';
                    if(!item.isLeaf&&!item.open&&item.children!==null){
                        arrow="right";
                    }
                    else if(!item.isLeaf&&item.open){
                        arrow="down";
                    }
                    if(show){
                        return <div style={{position:'relative',paddingLeft:'15px'}}>
                            <div className='refer-content' style={{borderBottom:'1px solid #CCCCCC'}}>
                                <SwipeAction style={{backgroundColor: 'gray'}}
                                             autoClose
                                             right={[
                                                 {
                                                     text: '取消',
                                                     onPress: () => console.log('cancel'),
                                                     style: {backgroundColor: '#ddd', color: 'white'},
                                                 },
                                                 {
                                                     text: '加入常用',
                                                     onPress: () => this.addUsed(item),
                                                     style: {backgroundColor: '#F4333C', color: 'white'},
                                                 },
                                             ]}
                                             onOpen={() => console.log('open')}
                                             onClose={() => console.log('close')}>
                                    <RadioItem style={{width:'85vw'}} checked={false}  onChange={(e) => this.onSingleChange(e,item)} key={index}>{item[this.props.displayField]}</RadioItem>
                                    {arrow!==''&&<div className='yyrefer-tree-icon-openclose' onClick={()=>{this._clickItem(item)}}>
                                        <Icon size="md"    type={arrow} color="#C7C7CC" />
                                    </div>}</SwipeAction>
                            </div>

                            <div style={{paddingLeft:'10px'}}>
                                {this.treeContent(item.children, selectedId,item.open)}
                            </div>

                        </div>
                            ;
                        /*else{
                             return <CheckboxItem checked={selectedId === item.id} className="refer-check-box" onChange={(e) => this.onSingleChange(e,item)} key={item.id}>{item[this.props.displayField]}</CheckboxItem>
                                 ;
                         }*/
                    }
                });
            }
        }else{
            if(treeData){
                return treeData.map((item,index) => {
                    let arrow = '';
                    if(!item.isLeaf&&!item.open&&item.children!==null){
                        arrow="right";
                    }
                    else if(!item.isLeaf&&item.open){
                        arrow="down";
                    }
                    if(show){
                        return <div style={{position:'relative',paddingLeft:'15px'}}>
                            <div className='refer-content' style={{borderBottom:'1px solid #CCCCCC'}}>
                                <SwipeAction style={{backgroundColor: 'gray'}}
                                             autoClose
                                             right={[
                                                 {
                                                     text: '取消',
                                                     onPress: () => console.log('cancel'),
                                                     style: {backgroundColor: '#ddd', color: 'white'},
                                                 },
                                                 {
                                                     text: '加入常用',
                                                     onPress: () => this.addUsed(item),
                                                     style: {backgroundColor: '#F4333C', color: 'white'},
                                                 },
                                             ]}
                                             onOpen={() => console.log('open')}
                                             onClose={() => console.log('close')}>
                                    <CheckboxItem style={{width:'85vw'}} checked={item.checked}  onChange={(e) => this.onMultiChange(e,item)} key={item.id}>{item[this.props.displayField]}</CheckboxItem>
                                    {arrow!==''&&<div className='yyrefer-tree-icon-openclose'>
                                        <Icon size="md"    type={arrow} color="#C7C7CC" onClick={()=>{this._clickItem(item)}}/>
                                    </div>}
                                </SwipeAction>
                            </div>
                            <div style={{paddingLeft:'10px'}}>
                                {this.treeContent(item.children, selectedId,item.open)}
                            </div>
                        </div>
                    }
                });
            }
            /*if(treeData){
                return treeData.map((item) => {
                    if (item.children && item.children.length > 0) {
                        return  <Accordion onChange={this.onChange} className="refer-accordion"  key={item.id}><Accordion.Panel className="refer-pad" key={item.id} header={ <CheckboxItem onChange={(e) => this.onMultiChange(e, item)} key={item.id} checked={item.checked} >{item[this.props.displayField]}</CheckboxItem>}>{this.treeContent(item.children, selectedId)}</Accordion.Panel></Accordion>;
                    }else{
                        return  <CheckboxItem className="refer-check-box" onChange={(e) => this.onMultiChange(e, item)} key={item.id} checked={item.checked}>{item[this.props.displayField]}</CheckboxItem>;
                    }
                });
            }*/
        }
    }
    handleClick = (item)=>{
        let fulldata = data[this.props.referName];
        let selectdata = this.state.selectedNodes;
        for(let i = 0;i < selectdata.length; i++){
            if(item === selectdata[i]){
                if(i==0){
                    selectdata.splice(0,1);
                } else {
                    selectdata.splice(i,1);
                }
                this.setState({
                    selectNodes:selectdata,
                    row:selectdata
                })
            }
        }

        let checkedfalse = (data)=>{
            for(let i = 0;i<data.length;i++){
                if(item.id == data[i].id){
                    data[i].checked = false;
                    return;
                } else {
                    if(data[i].children!==null){
                        checkedfalse(data[i].children)
                    }
                }
            }
        }
        checkedfalse(fulldata);
        /*for(let i = 0; i < fulldata.length;i++){
            if(item.id == fulldata[i].id){
                fulldata[i].checked = false;
            } else{

            }
        }*/
    }

    render() {

        const {value,selectedId,animating,pageNumber,showList} = this.state;
        const {referlabel,referCode,multiMode,displayField,disabled,referStyle,referName,open,modalHeight,isSearch} = this.props;

        return (
            <WingBlank>
                <WhiteSpace />
                <Modal
                    popup
                    visible={disabled?'':open}
                    maskClosable={false}
                    animationType="slide-up">
                    <div style={modalHeight=='part'?{height:'93vh',width:'100vw'}:{height:'100vh',width:'100vw',display:'flex',flexDirection:'column'}}>
                        <div className='Nav'>
                            <NavBar leftContent="返回"
                                    key="nav"
                                    mode="light"
                                    onLeftClick={this.onClose(referName)}
                                    rightContent={[
                                        <a key="nav" onClick={this.onOk(referName)}>确定</a>,
                                    ]}
                            >{referlabel}</NavBar>
                        </div>
                        <Tabs tabs={[{title: <Badge>常用</Badge>}, {title: <Badge>参照</Badge>}]} initialPage={0}
                              swipeable={false}
                              onChange={(tab, index) => {
                                  console.log('onChange', index, tab);
                              }}
                              onTabClick={(tab, index) => {
                                  this.TabChange(tab, index)
                              }}>
                            <div>
                                <List className="refer-tree-content">
                                    {this.usedTreeContent(data[referName+'used'], selectedId,true)}
                                </List>
                            </div>
                            <div>
                                <ActivityIndicator
                                    toast
                                    text="加载中..."
                                    animating={animating}
                                />

                                <List className="refer-tree-content">
                                    {isSearch&&<div className="YYRefer-search-clear"><SearchBar placeholder="搜索" className='yyrefer-tree-searchBar' onSubmit={this.onSearchSubmit}/></div>}
                                    {this.treeContent(data[referName+'tree'], selectedId,true)}
                                </List>
                            </div>
                        </Tabs>


                        {multiMode? <div className='yyrefer-tap'>
                            <div style={{width:'auto'}}>
                                <DeleteTap rows={this.state.row} displayField={displayField} handleClick={this.handleClick}/>
                            </div>
                        </div>:''}
                    </div>
                </Modal>
            </WingBlank>
        );
    }
}
YYReferTree.defaultProps = {
    referlabel: '参照',
    referCode: '00026',
    modalHeight:'all',
    displayField: 'name',
    referParams: {},
    multiMode: true,
    disabled:false,
    open:false,
    onOk:{},
    referName:'key',
    referStyle:'list',
    condition:{},
    listCondition:{},
    custom:false,
};
